Subject: Re: Get new_emac driver running on 405EP

From: Benjamin Herrenschmidt <[email-masked]>
Date: Tue, 15 Apr 2008 07:02:41 +1000

On Mon, 2008-04-14 at 19:38 +0200, M B wrote:
> Hi,
> I'm trying to get the new_emac driver (linux 2.6.25-rc8) running on my
> 405EP board with a KSZ8721BT Micrel/Kendin PHY.
> I've already found 2 problems/missing features:
> 1) 100 retries in __emac_mdio_read for the read to complete are
> slightly too less. 101 seem to be enough. But we could add a bit more,
> because there is no negative effect for faster chips.
> 2) On the 405EP only the MDIO pin of the emac0 is pinned out, so both
> phys have to be accessed through this one. This affectes the mdio
> read/write functions.

The later can easily be described in the device-tree as it's a fairly
common setup.

> I've already hacked around this problems, but ethernet is still not working.
> After bringing up the device dmesg is flooded with this section.
> emac/plb/opb/ethernet@ef600800: link timer
> emac/plb/opb/ethernet@ef600800: mdio_read(00,01)
> emac/plb/opb/ethernet@ef600800: mdio_read -> 786d
> emac/plb/opb/ethernet@ef600800: mdio_read(00,01)
> emac/plb/opb/ethernet@ef600800: mdio_read -> 786d
> 
> 
> Any ideas where I should start looking?

The above is the timer polling the link, you may want to remove that
debug once it looks sane.

Ben.